- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions

# MFnAnimCurve Class Reference

# OpenMayaAnim - API module for animation | FunctionSet classes

Search for all occurrences

## Detailed Description

Anim Curve Function Set.

Create, query and edit Anim Curve Nodes and the keys internal to those Nodes.

Create an Anim Curve Node and connect its output to any animatable attribute on another Node.

Evaluate an Anim Curve at a particular time.

Determine the number of keys held by an Anim Curve.

Determine the time and value of individual keys, as well as the (angle,weight) or (x,y) values and type of key tangents. The in-tangent refers to the tangent entering the key. The out-tangent refers to the tangent leaving the key.

Find the index of the key at, or closest to a particular time.

Set the time and value of individual keys, as well as the type of the tangent to the curve entering (in-tangent) and leaving (out-tangent) the key, specify the tangent as either (angle,weight) or (x,y).

Add and remove keys from an Anim Curve. Anim Curves are implemented as Dependency Graph (DG) Nodes. Each Node can have indexed keys.

There are eight different types of Anim Curve nodes:

- timeToAngular (animCurveTA)
- timeToLinear (animCurveTL)
- timeToTime (animCurveTT)
- timeToUnitless (animCurveTU)
- unitlessToAngular (animCurveUA)
- unitlessToLinear (animCurveUL)
- unitlessToTime (animCurveUT)
- unitlessToUnitless (animCurveUU)

Specifying the correct AnimCurveType during creation will avoid implicit unit conversion nodes.

Use the Anim Curve Function Set to create Anim Curve Nodes and connect them to animatable attributes on DG Nodes, as well as to query and edit an Anim Curve Node and its keys.

On creation, an Anim Curve Function Set may be attached to a given Anim Curve or it may be unattached. The Function Set may be attached to a different Anim Curve Node using the setObject() methods inherited from the Base Function Set (MFnBase) or with the create() methods.

Use the create() methods of an Anim Curve Function Set to create a new Anim Curve Node, attach the Function Set to the new Node and connect the output of the Node to a specific animatable Attribute or Plug of another Node. Additionally, the output of an Anim Curve Node may be attached to an Attribute or Plug of another DG Node using the DG Modifier method MDGModifier::connect().

Use the evaluate() methods to determine the value of an Anim Curve at a particular time or a given unitless input.

Use the addKey() and remove() methods to add and remove keys to and from an Anim Curve.

The query and edit methods of the Anim Curve Function Set act on keys at a specific 0-based index. [Note that the numKeys() method returns a 1-based value]. Keys can be accessed either randomly (via a 0-based index) or serially (using the find() and findClosest() methods).

Use the find() or findClosest() methods to determine the index of a key at or closest to a specific time respectively.

Use the specific query methods to determine the time, value and tangent information for a key at a given index.

Use the specific edit methods to set the time, value and tangent information for a key at a given index.

There are methods for setting the x,y values for the in- and out-tangents, as well as setting their angles and weights.

Setting the time of a key will fail if the new time would require a re-ordering of the keys. Use the remove() and addKey() methods to re-order the keys. Or use the keyframe command from mel.

The Maya developer's kit ships with example code (animDemo) which demonstrates how to evaluate a Maya animation curve independent from Maya. The animation parameter curves in Maya are defined by a restricted set of cubic two-dimensional Bezier curves. It is defined by four points. P1 = (x1, y1) is the (key,value) pair for the first key. P2 = (x2, y2) is a point which defines the outgoing tangent direction at P1. P4 = (x4, y4) defines the second key and P3 = (x3, y3) is a point which defines the incoming tangent direction at P4. There are some basic restrictions for the x coordinates of these points: x1 <= x2 <= x3 <= x4.

The 2-dimensional Bezier curve is defined as

      F(u) = [ u^3 u^2 u 1 ] * B * | P1 |   ,  0 <= u <= 1
                                   | P2 |
                                   | P3 |
                                   | P4 |

           = [ B0(u) B1(u) B2(u) B3(u) ] * | x1 y1 |
                                           | x2 y2 |
                                           | x3 y3 |
                                           | x4 y4 |

       where B is the Bezier Basis matrix  | -1  3  -3  1 |
                                           |  3 -6   3  0 |
                                           | -3  3   0  0 |
                                           |  1  0   0  0 |

F(u) yields a vector of two cubic polynomials [ Fx(u) Fy(u) ] which define an (x, y) position on the parameter curve for some u in the range [0,1].

For an animation parameter curve, we are given the x position and want to know its corresponding y position. To do this we use x = Fx(u) and solve for u. Fx(u) is cubic and the restrictions on valid values for x2 and x3 guarantee there will be only one real root value for u. Once we know u, we can plug it into Fy(u) to get the y value.

One important note is how the outgoing and incoming tangents directions for a key are saved internally and in the Maya Ascii file format. Instead of being specified as points, the tangent directions are specified as vectors. The outgoing tangent direction at P1 is specified and saved as the vector 3*(P2 - P1) and the incoming tangent direction is specified and saved as the vector 3*(P4 - P3).

An animation curve is basically a restricted form of a bezier curve for which the keys serve as the control points and have tangent information embedded within them. There are two different methods for converting tangent information into the control points of the bezier hull and we have taken to calling the two methods weighted and non-weighted tangents.

The animation curve is evaluated in a piecewise manner, which means that each segment between two keys is evaluated on its own, without regards to any other segment. The only time keys outside of a segment are considered is when tangent values are calculated for the spline, clamped, plateau or auto tangent types.

When evaluating an animation curve, a two stage process is used:

1. the evaluation time is examined to determine if it falls within the range of the animation curve, and if it does not evaluation is based upon the infinity settings for the animation curve.
2. if the evaluation time falls within the range of the animation curve, the bezier parameters of the curve are computed and used as described below.

Animation curves may have either weighted or non-weighted tangents. With non-weighted tangents, tangents are implemented as vectors and P2 and P3 are internally adjusted to account for the time difference between P1 and P4.

When evaluating a time within a segment, the following algortithms are used:

    For weighted tangents:
        where x is the start of the segment
        given the bezier x parameters a', b', c', d', find the parameter t
        which satisfies the formula:
            (time - x) = (t^3 * a') + (t^2 + b') + (t * c') + d'
        with t (and the bezier y parameters a, b, c, d) compute the value as:
            v = (t^3 * a) + (t^2 + b) + (t * c) + d

    For non-weighted tangents:
        where x is the start of the segment
        compute the parameter t as time - x
        with t (and the bezier y parameters a, b, c, d) compute the value as:
            v = (t^3 * a) + (t^2 + b) + (t * c) + d

Examples:

  animExportUtil.cpp, animFileExport.cpp, animFileUtils.cpp, createClipCmd.cpp, and spiralAnimCurveCmd.cpp.

`#include <MFnAnimCurve.h>`

Inheritance diagram for MFnAnimCurve:
[legend]

List of all members.

## Public Types
enum | AnimCurveType { kAnimCurveTA = 0, kAnimCurveTL, kAnimCurveTT, kAnimCurveTU, kAnimCurveUA, kAnimCurveUL, kAnimCurveUT, kAnimCurveUU, kAnimCurveUnknown }
| Defines the input and output type of the animation curve. More...
enum | TangentType { kTangentGlobal = 0, kTangentFixed, kTangentLinear, kTangentFlat, kTangentSmooth, kTangentStep, kTangentSlow, kTangentFast, kTangentClamped, kTangentPlateau, kTangentStepNext, kTangentAuto }
| Defines the type of the tangent. More...
enum | InfinityType { kConstant = 0, kLinear = 1, kCycle = 3, kCycleRelative = 4, kOscillate = 5 }
| Defines the type of the infinity. More...
## Public Member Functions
virtual MFn::Type | type () const
| Function set type.
virtual | ~MFnAnimCurve ()
| Destructor.
| MFnAnimCurve ()
| Default constructor.
| MFnAnimCurve (MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
| MFnAnimCurve (const MPlug &plug, MStatus *ReturnStatus=NULL)
| Class constructor that initializes the function set to the single Anim Curve Node connected to the given MPlug.
MObject | create (const MObject &node, const MObject &attribute, MDGModifier *modifier=NULL, MStatus *ReturnStatus=NULL)
| Creates a new Anim Curve Node, attaches the Function Set to the new Node (detaching from the current Node) and connects the output of the new Anim Curve Node to an animatable Attribute on another DG Node.
MObject | create (const MObject &node, const MObject &attribute, AnimCurveType animCurveType, MDGModifier *modifier=NULL, MStatus *ReturnStatus=NULL)
| Creates a new Anim Curve Node, attaches the Function Set to the new Node (detaching from the current Node) and connects the output of the new Anim Curve Node to an animatable Attribute on another DG Node.
MObject | create (const MPlug &plug, MDGModifier *modifier=NULL, MStatus *ReturnStatus=NULL)
| Creates a new Anim Curve Node, attaches the Function Set to the new Node (detaching from the current Node) and connects the output of the new Anim Curve Node to the Plug on an animatable Attribute on another DG Node.
MObject | create (const MPlug &plug, AnimCurveType animCurveType, MDGModifier *modifier=NULL, MStatus *ReturnStatus=NULL)
| Creates a new Anim Curve Node, attaches the Function Set to the new Node (detaching from the current Node) and connects the output of the new Anim Curve Node to the Plug on an animatable Attribute on another DG Node.
MObject | create (AnimCurveType animCurveType, MDGModifier *modifier=NULL, MStatus *ReturnStatus=NULL)
| Creates a new Anim Curve Node, attaches the Function Set to the new Node (detaching from the current Node) but does not attempt to connect the new Anim Curve Node.
AnimCurveType | animCurveType (MStatus *ReturnStatus=NULL) const
| Returns the animCurve type.
AnimCurveType | timedAnimCurveTypeForPlug (MPlug &plug, MStatus *ReturnStatus=NULL) const
| Returns the timed animCurve type appropriate for the specified plug.
AnimCurveType | unitlessAnimCurveTypeForPlug (MPlug &plug, MStatus *ReturnStatus=NULL) const
| Returns the unitless animCurve type appropriate for the specified plug.
double | evaluate (const MTime &atTime, MStatus *ReturnStatus=NULL) const
| Determines the interpolated output value of Anim Curves of type kAnimCurveTA, kAnimCurveTL and kAnimCurveTU at the specified time.
MStatus | evaluate (const MTime &atTime, double &value) const
| Determines the interpolated output value of Anim Curves of type kAnimCurveTA, kAnimCurveTL and kAnimCurveTU at the specified time.
MStatus | evaluate (const MTime &atTime, MTime &timeValue) const
| Determines the interpolated output value of Anim Curves of type kAnimCurveTT at the specified time.
MStatus | evaluate (const double &atUnitlessInput, double &value) const
| Determines the interpolated output value of Anim Curves of type kAnimCurveUA, kAnimCurveUL and kAnimCurveUU at the specified unitless input.
MStatus | evaluate (const double &atUnitlessInput, MTime &timeValue) const
| Determines the interpolated output value of Anim Curves of type kAnimCurveUT at the specified unitless input.
bool | isStatic (MStatus *ReturnStatus=NULL) const
| Determines whether or not the animCurve is static.
unsigned int | numKeyframes (MStatus *ReturnStatus=NULL) const
| This method is obsolete.
unsigned int | numKeys (MStatus *ReturnStatus=NULL) const
| Determines the number of keys on the Anim Curve Node.
MStatus | remove (unsigned int index, MAnimCurveChange *change=NULL)
| Removes the key at the specified index.
MStatus | addKeyframe (const MTime &time, double value, MAnimCurveChange *change=NULL)
| Adds a new key with the given value at the specified time.
MStatus | addKeyframe (const MTime &time, double value, TangentType tangentInType, TangentType tangentOutType, MAnimCurveChange *change=NULL)
| Adds a new key with the given value and tangent types at the specified time.
unsigned int | addKey (const MTime &time, double value, TangentType tangentInType=kTangentGlobal, TangentType tangentOutType=kTangentGlobal, MAnimCurveChange *change=NULL, MStatus *ReturnStatus=NULL)
| Adds a new key with the given value and tangent types at the specified time for curves of type kAnimCurveTA, kAnimCurveTL and kAnimCurveTU.
unsigned int | addKey (const MTime &timeInput, const MTime &timeValue, TangentType tangentInType=kTangentGlobal, TangentType tangentOutType=kTangentGlobal, MAnimCurveChange *change=NULL, MStatus *ReturnStatus=NULL)
| Adds a new key with the given output time value and tangent types at the specified input time for curves of type kAnimCurveTT.
unsigned int | addKey (double unitlessInput, double value, TangentType tangentInType=kTangentGlobal, TangentType tangentOutType=kTangentGlobal, MAnimCurveChange *change=NULL, MStatus *ReturnStatus=NULL)
| Adds a new key with the given value and tangent types at the specified unitless input for curves of type kAnimCurveUA, kAnimCurveUL and kAnimCurveUU.
unsigned int | addKey (double unitlessInput, const MTime &time, TangentType tangentInType=kTangentGlobal, TangentType tangentOutType=kTangentGlobal, MAnimCurveChange *change=NULL, MStatus *ReturnStatus=NULL)
| Adds a new key with the given output time value and tangent types at the specified unitless input for curves of type kAnimCurveUT.
MStatus | addKeys (MTimeArray *timeArray, MDoubleArray *valueArray, TangentType tangentInType=kTangentGlobal, TangentType tangentOutType=kTangentGlobal, bool keepExistingKeys=false, MAnimCurveChange *change=NULL)
| Add a set of new keys with the given corresponding values and tangent types at the specified times.
bool | find (const MTime &time, unsigned int &index, MStatus *ReturnStatus=NULL) const
| Determines the index of the key which is set at the specified time.
bool | find (double unitlessInput, unsigned int &index, MStatus *ReturnStatus=NULL) const
| Determines the index of the key which is set at the specified unitless input value.
unsigned int | findClosest (const MTime &time, MStatus *ReturnStatus=NULL) const
| Determines the index of the key which is set at the time closest to the specified time.
unsigned int | findClosest (double unitlessInput, MStatus *ReturnStatus=NULL) const
| Determines the index of the key which is set at the time closest to the specified unitless input value.
MTime | time (unsigned int index, MStatus *ReturnStatus=NULL) const
| Determines the time of the key at the specified index.
double | value (unsigned int index, MStatus *ReturnStatus=NULL) const
| Determines the value of the key at the specified index.
double | unitlessInput (unsigned int index, MStatus *ReturnStatus=NULL) const
| Determines the unitless input value of the key at the specified index.
MStatus | setValue (unsigned int index, double value, MAnimCurveChange *change=NULL)
| Sets the value of the key at the specified index.
MStatus | setTime (unsigned int index, const MTime &time, MAnimCurveChange *change=NULL)
| Sets the time of the key at the specified index.
MStatus | setUnitlessInput (unsigned int index, double unitlessInput, MAnimCurveChange *change=NULL)
| Sets the value of the unitless input of the key at the specified index.
bool | isTimeInput (MStatus *ReturnStatus=NULL) const
| Determines the input type of the animCurve.
bool | isUnitlessInput (MStatus *ReturnStatus=NULL) const
| Determines the input type of the animCurve.
TangentType | inTangentType (unsigned int index, MStatus *ReturnStatus=NULL) const
| Determines the type of the tangent to the curve entering the current key.
TangentType | outTangentType (unsigned int index, MStatus *ReturnStatus=NULL) const
| Determines the type of the tangent to the curve leaving the current key.
MStatus | setInTangentType (unsigned int index, TangentType tangentType, MAnimCurveChange *change=NULL)
| Sets the type of the tangent to the curve entering the key at the specified index.
MStatus | setOutTangentType (unsigned int index, TangentType tangentType, MAnimCurveChange *change=NULL)
| Sets the type of the tangent to the curve leaving the key at the specified index.
MStatus | setTangentTypes (MIntArray indexArray, TangentType tangentInType=kTangentGlobal, TangentType tangentOutType=kTangentGlobal, MAnimCurveChange *change=NULL)
| Sets the tangent types for multiple keys.
MStatus | getTangent (unsigned int index, float &x, float &y, bool inTangent) const
| Determines the x,y value representing the vector of the in- or out-tangent (depending on the value of the inTangent parameter) to the curve for the key at the specified index.
MStatus | getTangent (unsigned int index, MAngle &angle, double &weight, bool inTangent) const
| Determines the angle and weight of the in- or out-tangent to the curve for the key at the specified index.
MStatus | setTangent (unsigned int index, float x, float y, bool inTangent, MAnimCurveChange *change=NULL, bool convertUnits=true)
| Sets the tangent for the key at the specified index.
MStatus | setTangent (unsigned int index, const MAngle &angle, double weight, bool inTangent, MAnimCurveChange *change=NULL, bool convertUnits=true)
| Sets the tangent for the key at the specified index.
MStatus | setAngle (unsigned int index, const MAngle &angle, bool inTangent, MAnimCurveChange *change=NULL)
| Set the in- or out-angle of the tangent for the key at the given index.
MStatus | setWeight (unsigned int index, double weight, bool inTangent, MAnimCurveChange *change=NULL)
| Set the in- or out-weight of the tangent for the key at the given index.
bool | weightsLocked (unsigned int index, MStatus *ReturnStatus=NULL) const
| Determines whether the weights are locked at the given key.
bool | tangentsLocked (unsigned int index, MStatus *ReturnStatus=NULL) const
| Determines whether the tangents are locked at the given key.
MStatus | setWeightsLocked (unsigned int index, bool locked, MAnimCurveChange *change=NULL)
| Lock or unlock the weights at the given key.
MStatus | setTangentsLocked (unsigned int index, bool locked, MAnimCurveChange *change=NULL)
| Lock or unlock the tangents at the given key.
InfinityType | preInfinityType (MStatus *ReturnStatus=NULL) const
| Determines the behaviour of the curve for the range occurring before the first key.
InfinityType | postInfinityType (MStatus *ReturnStatus=NULL) const
| Determines the behaviour of the curve for the range occurring after the last key.
MStatus | setPreInfinityType (InfinityType infinityType, MAnimCurveChange *change=NULL)
| Set the behaviour of the curve for the range occurring before the first key.
MStatus | setPostInfinityType (InfinityType infinityType, MAnimCurveChange *change=NULL)
| Set the behaviour of the curve for the range occurring after the last key.
bool | isWeighted (MStatus *ReturnStatus=NULL) const
| Determines whether or not the curve has weighted tangents.
MStatus | setIsWeighted (bool isWeighted, MAnimCurveChange *change=NULL)
| Sets whether or not the curve has weighted tangents.
bool | isBreakdown (unsigned int index, MStatus *ReturnStatus=NULL) const
| Determines whether or not a key is a breakdown.
MStatus | setIsBreakdown (unsigned int index, bool isBreakdown, MAnimCurveChange *change=NULL)
| Sets the breakdown state of a key at a given index.
| MFnAnimCurve (const MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
## Protected Member Functions
virtual const char * | className () const
| Class name.

## Member Enumeration Documentation

enum AnimCurveType

Search for all occurrences

Defines the input and output type of the animation curve.

Animation curves in Maya support either time or unitless inputs. For example, curves set using setKeyframe have time inputs. Curves set using setDrivenKeyframe have unitless inputs. Maya supports four types of outputs: angular, linear, time and unitless. Time, angular and linear outputs work according to the units specified in user preferences and convert units when the preferences are changes. Unitless outputs are not sensitive to user preferences.

Enumerator:

  kAnimCurveTA | Time to Angular. Search for all occurrences
  kAnimCurveTL | Time to Linear. Search for all occurrences
  kAnimCurveTT | Time to Time. Search for all occurrences
  kAnimCurveTU | Time to Unitless. Search for all occurrences
  kAnimCurveUA | Unitless to Angular. Search for all occurrences
  kAnimCurveUL | Unitless to Linear. Search for all occurrences
  kAnimCurveUT | Unitless to Time. Search for all occurrences
  kAnimCurveUU | Unitless to Unitless. Search for all occurrences
  kAnimCurveUnknown | Unknown type. Search for all occurrences

enum TangentType

Search for all occurrences

Defines the type of the tangent.

Enumerator:

  kTangentGlobal | Global. Search for all occurrences
  kTangentFixed | Fixed. Search for all occurrences
  kTangentLinear | Linear. Search for all occurrences
  kTangentFlat | Flag. Search for all occurrences
  kTangentSmooth | Smooth. Search for all occurrences
  kTangentStep | Step. Search for all occurrences
  kTangentSlow | OBSOLETE kTangentSlow should not be used. Using this tangent type may produce unwanted and unexpected results. Search for all occurrences
  kTangentFast | OBSOLETE kTangentFast should not be used. Using this tangent type may produce unwanted and unexpected results. Search for all occurrences
  kTangentClamped | Clamped. Search for all occurrences
  kTangentPlateau | Plateau. Search for all occurrences
  kTangentStepNext | StepNext. Search for all occurrences
  kTangentAuto | Auto. Search for all occurrences

enum InfinityType

Search for all occurrences

Defines the type of the infinity.

The infinity controls the shape of the animation curve in the regions before the first key and after the last key.

Enumerator:

  kConstant | Constant. Search for all occurrences
  kLinear | Linear. Search for all occurrences
  kCycle | Cycle. Search for all occurrences
  kCycleRelative | Cycle relative. Search for all occurrences
  kOscillate | Oscillate. Search for all occurrences

## Constructor & Destructor Documentation

MFnAnimCurve | ( | MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnAnimCurve | ( | const MPlug & | plug,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Class constructor that initializes the function set to the single Anim Curve Node connected to the given MPlug.

It is possible for a plug to be connected to more than one Anim Curve Node (for example the plug may be connected to a choice node and then several Anim Curves may be connected to the choice node). In this case the function set will attach to one of the Anim Curve Nodes and return MS::kNotImplemented.

Parameters:

  [in] | plug | the MPlug to find a single Anim Curve Node
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MPlug does not represent a valid Maya object or if the function set is not allowed to attach to the Anim Curve Node
  - MS::kNotFound if the MPlug is not connected to an Anim Curve Node
  - MS::kNotImplemented if the MPlug is connected to more than one Anim Curve Node. The function set will be attached to one of the Anim Curve Nodes.

MFnAnimCurve | ( | const MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

## Member Function Documentation

MFn::Type type | ( |  | ) | const `[virtual]`

Search for all occurrences

Function set type.

Return the class type : MFn::kAnimCurve.

Reimplemented from MFnDependencyNode.

const char * className | ( |  | ) | const `[protected, virtual]`

Search for all occurrences

Class name.

Return the class name : "MFnAnimCurve".

Reimplemented from MFnDependencyNode.

MObject create | ( | const MObject & | node,
|  | const MObject & | attribute,
|  | MDGModifier * | modifier = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Creates a new Anim Curve Node, attaches the Function Set to the new Node (detaching from the current Node) and connects the output of the new Anim Curve Node to an animatable Attribute on another DG Node.

This method will fail if the target Attribute is not animatable, or if a connection to the target Attribute already exists.

Once the new Anim Curve Node has been created, the create() method finds the Plug associated with the target Attribute, makes sure the Attribute is animatable and then makes the connection.

The creation and connection of DG Nodes are DG operations. Operations on the DG are performed by DG Modifiers (MDGModifier). A DG Modifier provides methods for editing the DG, however, the operations are not performed immediately. DG operations must be undoable, therefore, the DG Modifier maintains a queue of pending DG operations which are performed when the MDGModifer::doIt() method is invoked. Subsequently, the queue of DG operations becomes the undo queue. When the MDGModifier::undoIt() method is invoked all of the operations on the queue are undone. DG operations on the queue can be done and undone as often as required as long as the Modifier exists and no other changes to the DG make the operations invalid. Once the Modifier holding the queue is destroyed, the queue is lost.

If a DG Modifier is passed as a parameter to this create() method, then that Modifier will be invoked to perform the creation and connection operations. At the completion of the create() method, the Modifier holds the necessary information to undo the operations, therefore, the caller of the create() method can undo the creation and connection if necessary.

If no Modifier is passed in, the create() method instantiates its own Modifier, uses it to perform the DG operations and then destroys the Modifier. The creation and connection, in this case, are not undoable by the caller.

Parameters:

  [in] | node | DG Node to which the output of the new Anim Curve Node is to be connected
  [in] | attribute | Attribute on the given node to which the output of the new Anim Curve Node is to be connected
  [in] | modifier | Modifier to be used so undo capability is retained by caller
  [in] | ReturnStatus | Status Code

Returns:
  The new Anim Curve Node

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for node and/or attribute - Node and/or Attribute inaccessible or non-existent, Attribute already connected as destination (fan-in not allowed), or Attribute is not animatable.
  - MS::kInsufficientMemory Insufficient memory to create new Node or temporary DG Modifier
  - MS::kLicenseFailure Application not licensed for attempted operation
  - MS::kFailure Could not modify DG

Examples:
  animFileUtils.cpp, createClipCmd.cpp, and spiralAnimCurveCmd.cpp.

MObject create | ( | const MObject & | node,
|  | const MObject & | attribute,
|  | AnimCurveType | animCurveType,
|  | MDGModifier * | modifier = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Creates a new Anim Curve Node, attaches the Function Set to the new Node (detaching from the current Node) and connects the output of the new Anim Curve Node to an animatable Attribute on another DG Node.

This method will fail if the target Attribute is not animatable, or if a connection to the target Attribute already exists.

Once the new Anim Curve Node has been created, the create() method finds the Plug associated with the target Attribute, makes sure the Attribute is animatable and then makes the connection.

The creation and connection of DG Nodes are DG operations. Operations on the DG are performed by DG Modifiers (MDGModifier). A DG Modifier provides methods for editing the DG, however, the operations are not performed immediately. DG operations must be undoable, therefore, the DG Modifier maintains a queue of pending DG operations which are performed when the MDGModifer::doIt() method is invoked. Subsequently, the queue of DG operations becomes the undo queue. When the MDGModifier::undoIt() method is invoked all of the operations on the queue are undone. DG operations on the queue can be done and undone as often as required as long as the Modifier exists and no other changes to the DG make the operations invalid. Once the Modifier holding the queue is destroyed, the queue is lost.

If a DG Modifier is passed as a parameter to this create() method, then that Modifier will be invoked to perform the creation and connection operations. At the completion of the create() method, the Modifier holds the necessary information to undo the operations, therefore, the caller of the create() method can undo the creation and connection if necessary.

If no Modifier is passed in, the create() method instantiates its own Modifier, uses it to perform the DG operations and then destroys the Modifier. The creation and connection, in this case, are not undoable by the caller.

Parameters:

  [in] | node | DG Node to which the output of the new Anim Curve Node is to be connected
  [in] | attribute | Attribute on the given node to which the output of the new Anim Curve Node is to be connected
  [in] | animCurveType | The animCurve Type to be created
  [in] | modifier | Modifier to be used so undo capability is retained by caller
  [out] | ReturnStatus | Status Code

Returns:
  The new Anim Curve Node

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for node and/or attribute - Node and/or Attribute inaccessible or non-existent, Attribute already connected as destination (fan-in not allowed), or Attribute is not animatable.
  - MS::kInsufficientMemory Insufficient memory to create new Node or temporary DG Modifier
  - MS::kLicenseFailure Application not licensed for attempted operation
  - MS::kFailure Could not modify DG

MObject create | ( | const MPlug & | plug,
|  | MDGModifier * | modifier = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Creates a new Anim Curve Node, attaches the Function Set to the new Node (detaching from the current Node) and connects the output of the new Anim Curve Node to the Plug on an animatable Attribute on another DG Node.

This method will fail if the target Attribute is not animatable, or if a connection to the target Attribute already exists.

If a DG Modifier is passed as a parameter to this create() method, then that Modifier will be invoked to perform the creation and connection operations. At the completion of the create() method, the Modifier holds the necessary information to undo the operations, therefore, the caller of the create() method can undo the creation and connection if necessary.

If no Modifier is passed in, the create() method instantiates its own Modifier, uses it to perform the DG operations and then destroys the Modifier. The creation and connection, in this case, are not undoable by the caller.

Parameters:

  [in] | plug | Plug to which the output of the new Anim Curve Node is to be connected
  [in] | modifier | Modifier to be used so undo capability is retained by caller
  [out] | ReturnStatus | Status Code

Returns:
  The new Anim Curve Node

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for plug - Attribute already connected as destination (fan-in not allowed), or Attribute is not animatable.
  - MS::kInsufficientMemory Insufficient memory to create new Node or temporary DG Modifier
  - MS::kLicenseFailure Application not licensed for attempted operation
  - MS::kFailure Could not modify DG

MObject create | ( | const MPlug & | plug,
|  | AnimCurveType | animCurveType,
|  | MDGModifier * | modifier = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Creates a new Anim Curve Node, attaches the Function Set to the new Node (detaching from the current Node) and connects the output of the new Anim Curve Node to the Plug on an animatable Attribute on another DG Node.

This method will fail if the target Attribute is not animatable, or if a connection to the target Attribute already exists.

If a DG Modifier is passed as a parameter to this create() method, then that Modifier will be invoked to perform the creation and connection operations. At the completion of the create() method, the Modifier holds the necessary information to undo the operations, therefore, the caller of the create() method can undo the creation and connection if necessary.

If no Modifier is passed in, the create() method instantiates its own Modifier, uses it to perform the DG operations and then destroys the Modifier. The creation and connection, in this case, are not undoable by the caller.

Parameters:

  [in] | plug | Plug to which the output of the new Anim Curve Node is to be connected
  [in] | animCurveType | The animCurve type to be created
  [in] | modifier | Modifier to be used so undo capability is retained by caller
  [out] | ReturnStatus | Status Code

Returns:
  The new Anim Curve Node

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for plug - Attribute already connected as destination (fan-in not allowed), or Attribute is not animatable.
  - MS::kInsufficientMemory Insufficient memory to create new Node or temporary DG Modifier
  - MS::kLicenseFailure Application not licensed for attempted operation
  - MS::kFailure Could not modify DG

MObject create | ( | AnimCurveType | animCurveType,
|  | MDGModifier * | modifier = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Creates a new Anim Curve Node, attaches the Function Set to the new Node (detaching from the current Node) but does not attempt to connect the new Anim Curve Node.

If a DG Modifier is passed as a parameter to this create() method, then that Modifier will be invoked to perform the creation and connection operations. At the completion of the create() method, the Modifier holds the necessary information to undo the operations, therefore, the caller of the create() method can undo the creation and connection if necessary.

If no Modifier is passed in, the create() method instantiates its own Modifier, uses it to perform the DG operations and then destroys the Modifier. The creation and connection, in this case, are not undoable by the caller.

Parameters:

  [in] | animCurveType | The type of Anim Curve to be created
  [in] | modifier | Modifier to be used so undo capability is retained by caller
  [out] | ReturnStatus | Status Code

Returns:
  The new Anim Curve Node

Status Codes:
  - MS::kSuccess Success
  - MS::kInsufficientMemory Insufficient memory to create new Node or temporary DG Modifier
  - MS::kLicenseFailure Application not licensed for attempted operation
  - MS::kFailure Could not modify DG

MFnAnimCurve::AnimCurveType animCurveType | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns the animCurve type.

Parameters:

  [out] | ReturnStatus | Status Code

Returns:
  The animCurve type.

Status Codes:
  - MS::kSuccess the animCurve type was returned successfully
  - MS::kFailure the animCurve type was not returned successfully

MFnAnimCurve::AnimCurveType timedAnimCurveTypeForPlug | ( | MPlug & | plug,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Returns the timed animCurve type appropriate for the specified plug.

Parameters:

  [in] | plug | plug
  [out] | ReturnStatus | Status Code

Returns:
  The animCurve type.

Status Codes:
  - MS::kSuccess the animCurve type was returned successfully
  - MS::kFailure the animCurve type was not returned successfully

MFnAnimCurve::AnimCurveType unitlessAnimCurveTypeForPlug | ( | MPlug & | plug,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Returns the unitless animCurve type appropriate for the specified plug.

Parameters:

  [in] | plug | plug
  [out] | ReturnStatus | Status Code

Returns:
  The animCurve type.

Status Codes:
  - MS::kSuccess the animCurve type was returned successfully
  - MS::kFailure the animCurve type was not returned successfully

double evaluate | ( | const MTime & | atTime,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines the interpolated output value of Anim Curves of type kAnimCurveTA, kAnimCurveTL and kAnimCurveTU at the specified time.

Parameters:

  [in] | atTime | Time at which the Anim Curve is to be evaluated
  [out] | ReturnStatus | Status Code .

Returns:
  Interpolated value of Anim Curve at specified time

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

MStatus evaluate | ( | const MTime & | atTime,
|  | double & | value
| ) |  | const

Search for all occurrences

Determines the interpolated output value of Anim Curves of type kAnimCurveTA, kAnimCurveTL and kAnimCurveTU at the specified time.

Parameters:

  [in] | atTime | Time at which the Anim Curve is to be evaluated
  [out] | value | Interpolated value of Anim Curve at specified time

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

MStatus evaluate | ( | const MTime & | atTime,
|  | MTime & | timeValue
| ) |  | const

Search for all occurrences

Determines the interpolated output value of Anim Curves of type kAnimCurveTT at the specified time.

Parameters:

  [in] | atTime | Time at which the Anim Curve is to be evaluated
  [out] | timeValue | Interpolated output time of Anim Curve at specified time

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

MStatus evaluate | ( | const double & | atUnitlessInput,
|  | double & | value
| ) |  | const

Search for all occurrences

Determines the interpolated output value of Anim Curves of type kAnimCurveUA, kAnimCurveUL and kAnimCurveUU at the specified unitless input.

Parameters:

  [in] | atUnitlessInput | Input value at which the Anim Curve is to be evaluated
  [out] | value | Interpolated output value of Anim Curve at specified input value

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

MStatus evaluate | ( | const double & | atUnitlessInput,
|  | MTime & | timeValue
| ) |  | const

Search for all occurrences

Determines the interpolated output value of Anim Curves of type kAnimCurveUT at the specified unitless input.

Parameters:

  [in] | atUnitlessInput | Input value at which the Anim Curve is to be evaluated
  [out] | timeValue | Interpolated output time of Anim Curve at specified time

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

bool isStatic | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines whether or not the animCurve is static.

The animCurve is considered to be static if it would return the same value regardless of the evaluation time. This basically means that the values of all the keys are the same and the y component of all the tangents is 0.

Parameters:

  [out] | ReturnStatus | Status Code .

Returns:
  Boolean value: true if the curve is static, false otherwise

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

unsigned int numKeyframes | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

This method is obsolete.

Deprecated:
  Use MFnAnimCurve::numKeys instead.

Parameters:

  [out] | ReturnStatus | Status Code

Returns:
  Number of keys on the Anim Curve Node

Examples:
  animFileUtils.cpp.

unsigned int numKeys | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines the number of keys on the Anim Curve Node.

Parameters:

  [out] | ReturnStatus | Status Code

Returns:
  Number of keys on the Anim Curve Node

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

MStatus remove | ( | unsigned int | index,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Removes the key at the specified index.

If this method is called from within an MItKeyframe iterator, the results are undefined (i.e., it is likely that the incorrect key will be removed). This is because keys are automatically sorted (i.e., assigned new index values) everytime time they are modified in such a manner that could cause them to change order (e.g., they are moved, keys are inserted or removed, etc.).

Parameters:

  [in] | index | Index of the key to be removed
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure editing Node - Node does not exist or is not accessible, or change could not be cached

MStatus addKeyframe | ( | const MTime & | time,
|  | double | value,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Adds a new key with the given value at the specified time.

Tangent types are set to kTangentGlobal. If you immediately query this key for its tangent type (after it is added), it will not be kTangentGlobal, rather it will be the specific type referred to by kTangentGlobal.

Parameters:

  [in] | time | Time at which the key is to be added
  [in] | value | Value to which the key is to be set
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure editing Node - Node does not exist or is not accessible, or change could not be cached

Examples:
  createClipCmd.cpp, and spiralAnimCurveCmd.cpp.

MStatus addKeyframe | ( | const MTime & | time,
|  | double | value,
|  | TangentType | tangentInType,
|  | TangentType | tangentOutType,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Adds a new key with the given value and tangent types at the specified time.

Parameters:

  [in] | time | Time at which the key is to be added
  [in] | value | Value to which the key is to be set
  [in] | tangentInType | In tangent type for the key
  [in] | tangentOutType | Out tangent type for the key
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure editing Node - Node does not exist or is not accessible, or change could not be cached

unsigned int addKey | ( | const MTime & | time,
|  | double | value,
|  | TangentType | tangentInType = `kTangentGlobal`,
|  | TangentType | tangentOutType = `kTangentGlobal`,
|  | MAnimCurveChange * | change = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Adds a new key with the given value and tangent types at the specified time for curves of type kAnimCurveTA, kAnimCurveTL and kAnimCurveTU.

Parameters:

  [in] | time | Time at which the key is to be added
  [in] | value | Value to which the key is to be set
  [in] | tangentInType | In tangent type for the key
  [in] | tangentOutType | Out tangent type for the key
  [out] | change | Optional cache to store undo/redo information.
  [out] | ReturnStatus | Status Code

Returns:
  Index of the added key

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure editing Node - Node does not exist or is not accessible, or change could not be cached

Examples:
  animFileUtils.cpp.

unsigned int addKey | ( | const MTime & | timeInput,
|  | const MTime & | timeValue,
|  | TangentType | tangentInType = `kTangentGlobal`,
|  | TangentType | tangentOutType = `kTangentGlobal`,
|  | MAnimCurveChange * | change = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Adds a new key with the given output time value and tangent types at the specified input time for curves of type kAnimCurveTT.

Parameters:

  [in] | timeInput | Time at which the key is to be added
  [in] | timeValue | Value to which the key is to be set
  [in] | tangentInType | In tangent type for the key
  [in] | tangentOutType | Out tangent type for the key
  [out] | change | Optional cache to store undo/redo information.
  [out] | ReturnStatus | Status Code

Returns:
  Index of the added key

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure editing Node - Node does not exist or is not accessible, or change could not be cached

unsigned int addKey | ( | double | unitlessInput,
|  | double | value,
|  | TangentType | tangentInType = `kTangentGlobal`,
|  | TangentType | tangentOutType = `kTangentGlobal`,
|  | MAnimCurveChange * | change = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Adds a new key with the given value and tangent types at the specified unitless input for curves of type kAnimCurveUA, kAnimCurveUL and kAnimCurveUU.

Parameters:

  [in] | unitlessInput | Unitless input at which the key is to be added
  [in] | value | Value to which the key is to be set
  [in] | tangentInType | In tangent type for the key
  [in] | tangentOutType | Out tangent type for the key
  [out] | change | Optional cache to store undo/redo information.
  [out] | ReturnStatus | Status Code

Returns:
  Index of added key

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure editing Node - Node does not exist or is not accessible, or change could not be cached

unsigned int addKey | ( | double | unitlessInput,
|  | const MTime & | timeValue,
|  | TangentType | tangentInType = `kTangentGlobal`,
|  | TangentType | tangentOutType = `kTangentGlobal`,
|  | MAnimCurveChange * | change = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Adds a new key with the given output time value and tangent types at the specified unitless input for curves of type kAnimCurveUT.

Parameters:

  [in] | unitlessInput | Unitless input at which the key is to be added
  [in] | timeValue | Value to which the key is to be set
  [in] | tangentInType | In tangent type for the key
  [in] | tangentOutType | Out tangent type for the key
  [out] | change | Optional cache to store undo/redo information.
  [out] | ReturnStatus | Status Code

Returns:
  Index of added key

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure editing Node - Node does not exist or is not accessible, or change could not be cached

MStatus addKeys | ( | MTimeArray * | timeArray,
|  | MDoubleArray * | valueArray,
|  | TangentType | tangentInType = `kTangentGlobal`,
|  | TangentType | tangentOutType = `kTangentGlobal`,
|  | bool | keepExistingKeys = `false`,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Add a set of new keys with the given corresponding values and tangent types at the specified times.

This method only works for Anim Curves of type kAnimCurveTA, kAnimCurveTL and kAnimCurveTU.

This method is tuned to provide best performance when:

- - the plug-in application pre-cuts the keys in the time range where the new keys are to be added
- - keepExistingKeys is set to false
- - change is NULL (i.e. the operation is not undoable)

These optimisations are geared towards motion capture plug-ins where a large numbers of keys must be added to a curve in a single operation.

Note: The timeArray and valueArray arrays are owned by the calling function. This method will copy those arrays to internal structures for use. As such, It is up to the caller to ensure that the memory allocated for the above arrays are deallocated appropriately.

Parameters:

  [in] | timeArray | Times at which keys are to be added
  [in] | valueArray | Values to which the keys is to be set
  [in] | tangentInType | In tangent type for all the added keys
  [in] | tangentOutType | Out tangent type for all the added keys
  [in] | keepExistingKeys | Specifies whether the new keys should be merged with existing keys, or if they should be cut prior to adding the new keys
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure editing Node - Node does not exist or is not accessible, or change could not be cached

bool find | ( | const MTime & | time,
|  | unsigned int & | index,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines the index of the key which is set at the specified time.

Parameters:

  [in] | time | Time for which a key index is required
  [in] | index | Key index at the specified time (implicit return)
  [out] | ReturnStatus | Status Code

Returns:
  Boolean value: true if the index is found false otherwise

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

bool find | ( | double | unitlessInput,
|  | unsigned int & | index,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines the index of the key which is set at the specified unitless input value.

Parameters:

  [in] | unitlessInput | Value for which a key index is required
  [in] | index | Key index at the specified time (implicit return)
  [out] | ReturnStatus | Status Code

Returns:
  Boolean value: true if the index is found false otherwise

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

unsigned int findClosest | ( | const MTime & | time,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines the index of the key which is set at the time closest to the specified time.

Parameters:

  [in] | time | Time for which a key index is required
  [out] | ReturnStatus | Status Code .

Returns:
  Key index closest to the specified time

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

unsigned int findClosest | ( | double | unitlessInput,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines the index of the key which is set at the time closest to the specified unitless input value.

Parameters:

  [in] | unitlessInput | Input value for which a key index is required
  [out] | ReturnStatus | Status Code .

Returns:
  Key index closest to the specified time

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

MTime time | ( | unsigned int | index,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines the time of the key at the specified index.

Parameters:

  [in] | index | Index of the key for which the time is required
  [out] | ReturnStatus | Status Code .

Returns:
  Time (in seconds) of the key

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

Examples:
  animFileUtils.cpp.

double value | ( | unsigned int | index,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines the value of the key at the specified index.

This method should only be used on Anim Curves of type kAnimCurve*A, kAnimCurve*L or kAnimCurve*U.

Parameters:

  [in] | index | Index of the key for which the value is required
  [out] | ReturnStatus | Status Code .

Returns:
  Value of the key

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

Examples:
  animFileUtils.cpp.

double unitlessInput | ( | unsigned int | index,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines the unitless input value of the key at the specified index.

This method should only be used on Anim Curves of type kAnimCurveU*.

Parameters:

  [in] | index | Index of the key for which the input value is required
  [out] | ReturnStatus | Status Code .

Returns:
  Input value at which the key is set

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

Examples:
  animFileUtils.cpp.

MStatus setValue | ( | unsigned int | index,
|  | double | value,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Sets the value of the key at the specified index.

This method should only be used on Anim Curves of type kAnimCurve*A, kAnimCurve*L or kAnimCurve*U.

Parameters:

  [in] | index | Index of the key for which the value is to be set
  [in] | value | Value to which the key is to be set
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure editing Node - Node does not exist or is not accessible

MStatus setTime | ( | unsigned int | index,
|  | const MTime & | time,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Sets the time of the key at the specified index.

This will fail if setting the time would require re-ordering of the keys. This method should only be used on Anim Curves of type kAnimCurveT*.

Tangents may be changed so that the curve remains monotonic with respect to time.

Parameters:

  [in] | index | Index of the key for which the time is to be set
  [in] | time | Time to which the indexed key time is to be set
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for time - time out of range and/or re-ordering of keys required
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure editing Node - Node does not exist or is not accessible

MStatus setUnitlessInput | ( | unsigned int | index,
|  | double | unitlessInput,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Sets the value of the unitless input of the key at the specified index.

This will fail if setting the value would require re-ordering of the keys. This methid should only be used on Anim Curves of type kAnimCurveU*.

Tangents may be changed so that the curve remains monotonic with respect to the unitless input.

Parameters:

  [in] | index | Index of the key for which the unitless input value is to be set
  [in] | unitlessInput | Value to which the indexed key unitless input value is to be set
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for time - time out of range and/or re-ordering of keys required
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure editing Node - Node does not exist or is not accessible

bool isTimeInput | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines the input type of the animCurve.

Parameters:

  [out] | ReturnStatus | Status Code .

Returns:
  Boolean value: true if the curve takes time as input false otherwise.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

Examples:
  animFileUtils.cpp.

bool isUnitlessInput | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines the input type of the animCurve.

Parameters:

  [out] | ReturnStatus | Status Code .

Returns:
  Boolean value: true if the curve takes a unitless value as input, false otherwise.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

Examples:
  animFileUtils.cpp.

MFnAnimCurve::TangentType inTangentType | ( | unsigned int | index,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines the type of the tangent to the curve entering the current key.

Parameters:

  [in] | index | Index of the key for which the tangent type is required
  [out] | ReturnStatus | Status Code .

Returns:
  Type of the tangent

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

Examples:
  animFileUtils.cpp.

MFnAnimCurve::TangentType outTangentType | ( | unsigned int | index,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines the type of the tangent to the curve leaving the current key.

Parameters:

  [in] | index | Index of the key for which the tangent type is required
  [out] | ReturnStatus | Status Code .

Returns:
  Type of the tangent

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

Examples:
  animFileUtils.cpp.

MStatus setInTangentType | ( | unsigned int | index,
|  | TangentType | tangentType,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Sets the type of the tangent to the curve entering the key at the specified index.

Parameters:

  [in] | index | Index of the key for which the tangent type is to be set
  [in] | tangentType | Type to which the tangent is to be set
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

MStatus setOutTangentType | ( | unsigned int | index,
|  | TangentType | tangentType,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Sets the type of the tangent to the curve leaving the key at the specified index.

Parameters:

  [in] | index | Index of the key for which the tangent type is to be set
  [in] | tangentType | Type to which the tangent is to be set
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

MStatus setTangentTypes | ( | MIntArray | indexArray,
|  | TangentType | inTangentType = `kTangentGlobal`,
|  | TangentType | outTangentType = `kTangentGlobal`,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Sets the tangent types for multiple keys.

Parameters:

  [in] | indexArray | Indices of the key for which the tangent type is to be set
  [in] | inTangentType | Type to which the in tangent is to be set
  [in] | outTangentType | Type to which the out tangent is to be set
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible

MStatus getTangent | ( | unsigned int | index,
|  | float & | x,
|  | float & | y,
|  | bool | inTangent
| ) |  | const

Search for all occurrences

Determines the x,y value representing the vector of the in- or out-tangent (depending on the value of the inTangent parameter) to the curve for the key at the specified index.

The values returned will be in Maya's internal units (seconds for time, centimeters for linear, radians for angles). The following examples demonstrates how to convert from internal units of seconds into the current user time unit.

        float x,y;
        animCurveFn.getTangent(i,x,y,true);
        MTime convert(1.0, MTime::kSeconds);
        x *= (float) convert.as(MTime::uiUnit());

Parameters:

  [in] | index | Index of the key for which the tangent x,y value is required
  [out] | x | The x value of the slope of the tangent in seconds
  [out] | y | Absolute y value of the slope of the tangent
  [in] | inTangent | If true, the in-tangent is returned, else, the out-tangent is returned

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

Examples:
  animFileUtils.cpp.

MStatus getTangent | ( | unsigned int | index,
|  | MAngle & | angle,
|  | double & | weight,
|  | bool | inTangent
| ) |  | const

Search for all occurrences

Determines the angle and weight of the in- or out-tangent to the curve for the key at the specified index.

Recall that tangents are stored as vectors internally and in the Maya Ascii file format. This means that the returned angle and weight will be converted from an (x,y) pair to represent the vector according to the following formula:

            angle = atan(y/x)
            weight = x/(3*cos(angle))

where x is in seconds and y is in centimeters for linear units and radians for angular units.

Parameters:

  [in] | index | Index of the key for which the tangent x,y value is required
  [out] | angle | The tangent angle
  [out] | weight | The tangent weight
  [in] | inTangent | If true, the inTangent is returned, else, the outTangent is returned

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

MStatus setTangent | ( | unsigned int | index,
|  | float | x,
|  | float | y,
|  | bool | inTangent,
|  | MAnimCurveChange * | change = `NULL`,
|  | bool | convertUnits = `true`
| ) |  |

Search for all occurrences

Sets the tangent for the key at the specified index.

If convertUnits is true (the default) the x value will be scaled by the current UI time units and the y value will be scaled by the relevant UI units for the output type of the animation curve (i.e. linear units for a curve that outputs linear data, and so on).

Note that if this method is called on a locked tangent (which they are by default), the corresponding out- or in-tangent will be modified as well (i.e., they will both be set to fixed). To prevent this from occurring, you must first unlock the tangent, make your modifications and then restore the lock setting for the tangent afterwards.

Parameters:

  [in] | index | Index of the key for which the tangent type is to be set
  [in] | x | Absolute x value of the slope of the tangent
  [in] | y | Absolute y value of the slope of the tangent
  [in] | inTangent | If true, the inTangent is modified, else, the outTangent is modified
  [out] | change | Optional cache to store undo/redo information.
  [in] | convertUnits | Whether to convert to UI units before setting

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

Examples:
  animFileUtils.cpp.

MStatus setTangent | ( | unsigned int | index,
|  | const MAngle & | angle,
|  | double | weight,
|  | bool | inTangent,
|  | MAnimCurveChange * | change = `NULL`,
|  | bool | convertUnits = `true`
| ) |  |

Search for all occurrences

Sets the tangent for the key at the specified index.

If convertUnits is true (the default) the x value will be scaled by the current UI time units and the y value will be scaled by the relevant UI units for the output type of the animation curve (i.e. linear units for a curve that outputs linear data, and so on).

Recall that tangents are stored as vectors internally and in the Maya Ascii file format. This means that the provided angle and weight will be converted into an (x,y) pair to represent the vector according to the following formula:

            x = 3 * weight * cos(angle)
            y = 3 * weight * sin(angle)

Note that if this method is called on a locked tangent (which they are by default), the corresponding out- or in-tangent will be modified as well (i.e., they will both be set to fixed). To prevent this from occurring, you must first unlock the tangent, make your modifications and then restore the lock setting for the tangent afterwards.

Parameters:

  [in] | index | Index of the key for which the tangent type is to be set
  [in] | angle | The angle to set the tangent
  [in] | weight | The weight to set the tangent
  [in] | inTangent | If true, the inTangent is modified, else, the outTangent is modified
  [out] | change | Optional cache to store undo/redo information.
  [in] | convertUnits | Whether to convert to UI units before setting

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

MStatus setAngle | ( | unsigned int | index,
|  | const MAngle & | angle,
|  | bool | inTangent,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Set the in- or out-angle of the tangent for the key at the given index.

Note that if this method is called on a locked tangent (which they are by default), the corresponding out- or in-tangent will be modified as well (i.e., they will both be set to fixed). To prevent this from occurring, you must first unlock the tangent, make your modifications and then restore the lock setting for the tangent afterwards.

Parameters:

  [in] | index | Index of the key
  [in] | angle | The new in- or out-angle for the key's tangent
  [in] | inTangent | If true, set the in-tangent, else out-tangent
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

MStatus setWeight | ( | unsigned int | index,
|  | double | weight,
|  | bool | inTangent,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Set the in- or out-weight of the tangent for the key at the given index.

Note that if this method is called on a locked weight (which they are by default), the corresponding out- or in-weight will be modified as well. To prevent this from occurring, you must first unlock the weight, make your modifications and then restore the lock setting for the weight afterwards.

Parameters:

  [in] | index | Index of the key
  [in] | weight | The new in- or out-weight for the key's tangent
  [in] | inTangent | If true, set the in-tangent, else set out-tangent
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

bool weightsLocked | ( | unsigned int | index,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines whether the weights are locked at the given key.

Parameters:

  [in] | index | Index of the key to check for locked weights
  [out] | ReturnStatus | Status Code .

Returns:
  Boolean value: true if the weights are locked, false otherwise.

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

Examples:
  animFileUtils.cpp.

bool tangentsLocked | ( | unsigned int | index,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines whether the tangents are locked at the given key.

Parameters:

  [in] | index | Index of the key to check for locked tangents
  [out] | ReturnStatus | Status Code .

Returns:
  Boolean value: true if the tangents are locked, false otherwise.

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

Examples:
  animFileUtils.cpp.

MStatus setWeightsLocked | ( | unsigned int | index,
|  | bool | locked,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Lock or unlock the weights at the given key.

Parameters:

  [in] | index | Index of the key at which to set/unset the locks
  [in] | locked | true if the weights are to be locked, false otherwise
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

Examples:
  animFileUtils.cpp.

MStatus setTangentsLocked | ( | unsigned int | index,
|  | bool | locked,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Lock or unlock the tangents at the given key.

Parameters:

  [in] | index | Index of the key at which to set/unset the locks
  [in] | locked | true if the tangents are to be locked, false otherwise
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

Examples:
  animFileUtils.cpp.

MFnAnimCurve::InfinityType preInfinityType | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines the behaviour of the curve for the range occurring before the first key.

Parameters:

  [out] | ReturnStatus | Status Code .

Returns:
  The current preInfinityType for the curve

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

Examples:
  animFileUtils.cpp.

MFnAnimCurve::InfinityType postInfinityType | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines the behaviour of the curve for the range occurring after the last key.

Parameters:

  [out] | ReturnStatus | Status Code .

Returns:
  The current postInfinityType for the curve

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

Examples:
  animFileUtils.cpp.

MStatus setPreInfinityType | ( | MFnAnimCurve::InfinityType | infinityType,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Set the behaviour of the curve for the range occurring before the first key.

Parameters:

  [in] | infinityType | The infinity type to be set.
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

Examples:
  animFileUtils.cpp.

MStatus setPostInfinityType | ( | MFnAnimCurve::InfinityType | infinityType,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Set the behaviour of the curve for the range occurring after the last key.

Parameters:

  [in] | infinityType | The infinity type to be set.
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible, or key does not exist or is not accessible, or index is invalid

Examples:
  animFileUtils.cpp.

bool isWeighted | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines whether or not the curve has weighted tangents.

Parameters:

  [out] | ReturnStatus | Status Code .

Returns:
  Boolean value: true if the curve has weighted tangents, false otherwise.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

Examples:
  animFileUtils.cpp.

MStatus setIsWeighted | ( | bool | isWeighted,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Sets whether or not the curve has weighted tangents.

Parameters:

  [in] | isWeighted | Whether or not the curve should have weighted tangents
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure Failure editing Node - Node does not exist or is not accessible, or change could not be cached

Examples:
  animFileUtils.cpp.

bool isBreakdown | ( | unsigned int | index,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines whether or not a key is a breakdown.

Parameters:

  [in] | index | The key's index
  [out] | ReturnStatus | Status Code .

Returns:
  Boolean value: true if the key is a breakdown, false otherwise.

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure querying Node - Node does not exist or is not accessible

Examples:
  animFileUtils.cpp.

MStatus setIsBreakdown | ( | unsigned int | index,
|  | bool | isBreakdown,
|  | MAnimCurveChange * | change = `NULL`
| ) |  |

Search for all occurrences

Sets the breakdown state of a key at a given index.

Parameters:

  [in] | index | Index of the key whose breakdown state is to be modified
  [in] | isBreakdown | The new breakdown state for the key.
  [out] | change | Optional cache to store undo/redo information.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kIndexOutOfRange Invalid parameter passed for index - index out of range (index >= numKeys)
  - MS::kFailure Failure editing Node - Node does not exist or is not accessible, or change could not be cached

Examples:
  animFileUtils.cpp.

MFnAnimCurve MFnAnimCurve MFnAnimCurve MFnAnimCurve MFnAnimCurve MFnAnimCurve MFnAnimCurve MFnAnimCurve MFnAnimCurve MFnAnimCurve
MFnAnimCurve MFnAnimCurve MFnAnimCurve MFnAnimCurve MFnAnimCurve MFnAnimCurve MFnAnimCurve MFnAnimCurve MFnAnimCurve MFnAnimCurve